/*
 * Copyright (c) 2002 - trem0r
 * This file is part of the PornView - photo collection manager.
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "pornview.h"

gint
cache_ensure_dir_exists (gchar * path, mode_t mode)
{
    if (!path)
	return FALSE;

    if (!isdir (path))
    {
	gchar  *p = path;
	while (p[0] != '\0')
	{
	    p++;
	    if (p[0] == '/' || p[0] == '\0')
	    {
		gint    end = TRUE;
		if (p[0] != '\0')
		{
		    p[0] = '\0';
		    end = FALSE;
		}
		if (!isdir (path))
		{
		    if (mkdir (path, mode) < 0)
		    {
			printf ("create dir failed: %s\n", path);
			return FALSE;
		    }
		}
		if (!end)
		    p[0] = '/';
	    }
	}
    }
    return TRUE;
}

gchar  *
cache_get_location (const gchar * source, gint include_name,
		    const gchar * ext, mode_t * mode)
{
    gchar  *path = NULL;
    gchar  *base;
    gchar  *name = NULL;

    if (!source)
	return NULL;

    base = remove_level_from_path (source);
    if (include_name)
    {
	name = g_strconcat ("/", filename_from_path (source), NULL);
    }
    else
    {
	ext = NULL;
    }

    if (conf.enable_thumb_dirs && access (base, W_OK) == 0)
    {
	path = g_strconcat (base, "/", PORNVIEW_CACHE_DIR, name, ext, NULL);
	if (mode)
	    *mode = 0775;
    }

    if (!path)
    {
	path =
	    g_strconcat (home_dir (), "/", PORNVIEW_RC_DIR_THUMBS, base, name,
			 ext, NULL);
	if (mode)
	    *mode = 0755;
    }

    g_free (base);
    if (name)
	g_free (name);

    return path;
}

gchar  *
cache_find_location (const gchar * source, const gchar * ext)
{
    gchar  *path;
    const gchar *name;
    gchar  *base;

    if (!source)
	return NULL;

    name = filename_from_path (source);
    base = remove_level_from_path (source);

    if (conf.enable_thumb_dirs)
    {
	path =
	    g_strconcat (base, "/", PORNVIEW_CACHE_DIR, "/", name, ext, NULL);
    }
    else
    {
	path =
	    g_strconcat (home_dir (), "/", PORNVIEW_RC_DIR_THUMBS, source,
			 ext, NULL);
    }

    if (!isfile (path))
    {
	g_free (path);

	/*
	 * try the opposite method if not found 
	 */
	if (!conf.enable_thumb_dirs)
	{
	    path =
		g_strconcat (base, "/", PORNVIEW_CACHE_DIR, "/", name, ext,
			     NULL);
	}
	else
	{
	    path =
		g_strconcat (home_dir (), "/", PORNVIEW_RC_DIR_THUMBS, source,
			     ext, NULL);
	}
    }

    if (!isfile (path))
    {
	g_free (path);
	path = NULL;
    }

    g_free (base);

    return path;
}
