/*
 * Copyright (c) 2002 - trem0r
 * This file is part of the PornView - photo collection manager.
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "pornview.h"

typedef struct _ImageTypeData
{
    gchar  *ext;
    gint    type;
    gchar  *description;
}
ImageTypeData;

ImageTypeData image_type[] = {
    {"jpg", IMAGETYPE_IMAGE, "JPEG"},
    {"jpe", IMAGETYPE_IMAGE, "JPEG"},
    {"jpeg", IMAGETYPE_IMAGE, "JPEG"},
    {"png", IMAGETYPE_IMAGE, "PNG"},
#ifdef ENABLE_XINE
    {"mpg", IMAGETYPE_MOVIE, "MPEG"},
    {"mpeg", IMAGETYPE_MOVIE, "MPEG"},
    {"m2v", IMAGETYPE_MOVIE, "MPEG"},
    {"vob", IMAGETYPE_MOVIE, "MPEG"},
    {"avi", IMAGETYPE_MOVIE, "AVI"},
    {"asf", IMAGETYPE_MOVIE, "ASF"},
    {"wmv", IMAGETYPE_MOVIE, "WMV"},
    {"qt", IMAGETYPE_MOVIE, "QuickTime"},
    {"mov", IMAGETYPE_MOVIE, "QuickTime"},
#endif
    {NULL, 0, NULL}
};

ImageType
image_type_check (gchar * file)
{
    gint    i;

    for (i = 0; image_type[i].ext; i++)
    {
	if (!strcasecmp (extension (file), image_type[i].ext))
	    return image_type[i].type;
    }

    return IMAGETYPE_UNKNOWN;
}
