/*
 * Copyright (c) 2002 - trem0r
 * This file is part of the PornView - photo collection manager.
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef USE_GTK2
#define GTK_ENABLE_BROKEN 1
#include <gtk/gtktext.h>
#endif

#include "pornview.h"

#include "pixmaps/jpeg.xpm"

static GdkPixmap *jpeg_pixmap = NULL;
static GdkBitmap *jpeg_mask = NULL;

static void imageinfo_set_data (void);
static gint valcomp (gconstpointer a, gconstpointer b);

static void cb_imageinfo_dialog_prev (GtkWidget * widget, gpointer data);
static void cb_imageinfo_dialog_next (GtkWidget * widget, gpointer data);
static void cb_imageinfo_dialog_close (GtkWidget * widget, gpointer data);

static GtkWidget *pixmap = NULL;
static GtkWidget *text = NULL;
static GtkWidget *label = NULL;
static GtkWidget *button_prev = NULL;
static GtkWidget *button_next = NULL;

static guint list_length;
static guint list_idx;
static GList *list = NULL;

void
imageinfo_dialog (void)
{
    GtkWidget *dialog;
    GtkWidget *dialog_vbox;
    GtkWidget *frame;
    GtkWidget *hbox1;
    GtkWidget *vseparator;
    GtkWidget *hbox2;
    GtkWidget *dialog_action_area;
    GtkWidget *hbox3;
    GtkWidget *button;
    GtkWidget *arrow;

    list_length = g_list_length (ZLIST (thumbview->album)->selection);
    list_length--;
    list_idx = 0;

    list = g_list_copy (ZLIST (thumbview->album)->selection);
    list = g_list_sort (list, (GCompareFunc) valcomp);

    dialog = gtk_dialog_new ();
    gtk_object_set_data (GTK_OBJECT (dialog), "dialog", dialog);
    gtk_window_set_title (GTK_WINDOW (dialog), "Image Properites");

#ifndef USE_GTK2
    GTK_WINDOW (dialog)->type = GTK_WINDOW_DIALOG;
#endif

    gtk_window_set_position (GTK_WINDOW (dialog), GTK_WIN_POS_MOUSE);
    gtk_window_set_policy (GTK_WINDOW (dialog), FALSE, FALSE, FALSE);
    gtk_window_set_transient_for (GTK_WINDOW (dialog),
				  GTK_WINDOW (browser->window));
    gtk_widget_set_usize (GTK_WIDGET (dialog), 400, 200);

    gtk_widget_realize (dialog);

    jpeg_pixmap =
	gdk_pixmap_create_from_xpm_d (dialog->window, &jpeg_mask, NULL,
				      jpeg_xpm);

    dialog_vbox = GTK_DIALOG (dialog)->vbox;
    gtk_object_set_data (GTK_OBJECT (dialog), "dialog_vbox", dialog_vbox);
    gtk_widget_show (dialog_vbox);

    hbox1 = gtk_hbox_new (FALSE, 0);
    gtk_widget_ref (hbox1);
    gtk_object_set_data_full (GTK_OBJECT (dialog), "hbox1", hbox1,
			      (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show (hbox1);

    gtk_box_pack_start (GTK_BOX (dialog_vbox), hbox1, TRUE, TRUE, 0);

    frame = gtk_frame_new (NULL);
    gtk_widget_ref (frame);
    gtk_object_set_data_full (GTK_OBJECT (dialog), "frame", frame,
			      (GtkDestroyNotify) gtk_widget_unref);
    gtk_frame_set_shadow_type (GTK_FRAME (frame), GTK_SHADOW_OUT);
    gtk_widget_show (frame);
    gtk_box_pack_start (GTK_BOX (hbox1), frame, TRUE, TRUE, 0);

    hbox2 = gtk_hbox_new (FALSE, 0);
    gtk_widget_ref (hbox2);
    gtk_object_set_data_full (GTK_OBJECT (dialog), "hbox2", hbox2,
			      (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show (hbox2);
    gtk_container_add (GTK_CONTAINER (frame), hbox2);

    pixmap = gtk_pixmap_new (jpeg_pixmap, jpeg_mask);
    gtk_widget_set_usize (GTK_WIDGET (pixmap), 120, 150);
    gtk_widget_show (pixmap);
    gtk_container_add (GTK_CONTAINER (hbox2), pixmap);

    vseparator = gtk_vseparator_new ();
    gtk_widget_ref (vseparator);
    gtk_object_set_data_full (GTK_OBJECT (dialog), "vseparator", vseparator,
			      (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show (vseparator);
    gtk_box_pack_start (GTK_BOX (hbox2), vseparator, TRUE, TRUE, 0);

    text = gtk_text_new (NULL, NULL);
    gtk_widget_ref (text);
    gtk_object_set_data_full (GTK_OBJECT (dialog), "text", text,
			      (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show (text);
    gtk_box_pack_start (GTK_BOX (hbox2), text, FALSE, FALSE, 0);

    gtk_widget_set_usize (GTK_WIDGET (text), 280, 150);

    dialog_action_area = GTK_DIALOG (dialog)->action_area;
    gtk_object_set_data (GTK_OBJECT (dialog), "dialog_action_area",
			 dialog_action_area);
    gtk_widget_show (dialog_action_area);
    gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area), 10);

    hbox3 = gtk_hbox_new (FALSE, 0);
    gtk_widget_ref (hbox3);
    gtk_object_set_data_full (GTK_OBJECT (dialog), "hbox3", hbox3,
			      (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show (hbox3);
    gtk_box_pack_start (GTK_BOX (dialog_action_area), hbox3, TRUE, TRUE, 0);

    button_prev = gtk_button_new ();
    arrow = gtk_arrow_new (GTK_ARROW_LEFT, GTK_SHADOW_NONE);
    gtk_container_add (GTK_CONTAINER (button_prev), arrow);
    gtk_widget_show (arrow);

    gtk_widget_ref (button_prev);
    gtk_object_set_data_full (GTK_OBJECT (dialog), "button_prev", button_prev,
			      (GtkDestroyNotify) gtk_widget_unref);

    gtk_widget_show (button_prev);
    gtk_widget_set_usize (GTK_WIDGET (button_prev), 25, 10);
    gtk_box_pack_start (GTK_BOX (hbox3), button_prev, FALSE, TRUE, 0);
    GTK_WIDGET_SET_FLAGS (button_prev, GTK_CAN_DEFAULT);

    gtk_signal_connect (GTK_OBJECT (button_prev), "clicked",
			GTK_SIGNAL_FUNC (cb_imageinfo_dialog_prev), NULL);
    gtk_widget_set_sensitive (button_prev, FALSE);

    button_next = gtk_button_new ();
    arrow = gtk_arrow_new (GTK_ARROW_RIGHT, GTK_SHADOW_NONE);
    gtk_container_add (GTK_CONTAINER (button_next), arrow);
    gtk_widget_show (arrow);
    gtk_widget_ref (button_next);
    gtk_object_set_data_full (GTK_OBJECT (dialog), "button_next", button_next,
			      (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show (button_next);
    gtk_widget_set_usize (GTK_WIDGET (button_next), 25, 10);

    gtk_box_pack_start (GTK_BOX (hbox3), button_next, FALSE, TRUE, 0);
    GTK_WIDGET_SET_FLAGS (button_next, GTK_CAN_DEFAULT);

    gtk_signal_connect (GTK_OBJECT (button_next), "clicked",
			GTK_SIGNAL_FUNC (cb_imageinfo_dialog_next), NULL);

    label = gtk_label_new (" ");
    gtk_widget_ref (label);
    gtk_object_set_data_full (GTK_OBJECT (dialog), "label", label,
			      (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show (label);
    gtk_box_pack_start (GTK_BOX (hbox3), label, TRUE, TRUE, 0);

    button = gtk_button_new_with_label ("Close");
    gtk_widget_ref (button);
    gtk_object_set_data_full (GTK_OBJECT (dialog), "button", button,
			      (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show (button);

#ifdef USE_GTK2
    gtk_widget_set_usize (GTK_WIDGET (button), 280, -2);
#else
    gtk_widget_set_usize (GTK_WIDGET (button), 280, 35);
#endif

    gtk_box_pack_start (GTK_BOX (hbox3), button, FALSE, TRUE, 0);

    GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
    gtk_widget_grab_default (button);

    gtk_signal_connect (GTK_OBJECT (button), "clicked",
			GTK_SIGNAL_FUNC (cb_imageinfo_dialog_close), dialog);

    gtk_widget_show (dialog);

    imageinfo_set_data ();
}

static void
imageinfo_set_data (void)
{
    ZAlbumCell *cell;
    struct tm *tp;
    char    buf[PATH_MAX];
    time_t  time;
    gint    width;
    gint    height;
    gint    size;
    gint    type;

    cell =
	ZLIST_CELL_FROM_INDEX (ZLIST (thumbview->album), (guint) list->data);

    type =
	(gint) zalbum_get_cell_data (ZALBUM (thumbview->album),
				     (guint) list->data);

    image_load_dimensions ((gchar *) cell->name, &width, &height);

    time = filetime (cell->name);
    size = filesize (cell->name);
    tp = gmtime (&time);

    snprintf (buf, PATH_MAX,
	      "\n\n name:   %s\n type:   %s\n width:  %d\n height: %d\n size:   %3.2fKB\n"
	      " time:   %02d.%02d.%d\n",
	      cell->name, (type == IMAGETYPE_IMAGE) ? "image" : "movie",
	      width, height, size / (gfloat) 1024, (tp->tm_mday),
	      (tp->tm_mon + 1), (tp->tm_year + 1900));

    if (cell->ipix)
	gtk_pixmap_set (GTK_PIXMAP (pixmap), cell->ipix, NULL);

    gtk_text_freeze (GTK_TEXT (text));
    gtk_text_backward_delete (GTK_TEXT (text),
			      gtk_text_get_length (GTK_TEXT (text)));

#ifdef USE_GTK2
    gtk_text_insert (GTK_TEXT (text), NULL, NULL, NULL, buf, -1);
#else
    gtk_text_insert (GTK_TEXT (text),
		     gdk_font_load
		     ("-misc-fixed-medium-r-normal-*-13-*-*-*-c-*-*-*"), NULL,
		     NULL, buf, -1);
#endif

    gtk_text_thaw (GTK_TEXT (text));

    if (list_length > 0)
    {
	snprintf (buf, PATH_MAX, "%d/%d", list_idx + 1, list_length + 1);
	gtk_label_set_text (GTK_LABEL (label), buf);
    }

    gtk_widget_set_sensitive (button_prev, list_idx != 0);
    gtk_widget_set_sensitive (button_next, list_length != list_idx);
}

static  gint
valcomp (gconstpointer a, gconstpointer b)
{
    if ((guint) a > (guint) b)
	return 1;
    else if ((guint) a < (guint) b)
	return -1;

    return 0;
}

static void
cb_imageinfo_dialog_prev (GtkWidget * widget, gpointer data)
{
    list_idx--;

    if (list_idx < 0)
	list_idx = 0;

    list = g_list_previous (list);

    imageinfo_set_data ();
}

static void
cb_imageinfo_dialog_next (GtkWidget * widget, gpointer data)
{
    list_idx++;

    if (list_idx > list_length)
	list_idx = list_length;

    list = g_list_next (list);

    imageinfo_set_data ();
}

static void
cb_imageinfo_dialog_close (GtkWidget * widget, gpointer data)
{
    g_list_free (list);

    gtk_widget_destroy (GTK_WIDGET (data));
}
