/*
 * Copyright (c) 2002 - trem0r
 * This file is part of the PornView - photo collection manager.
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "pornview.h"

extern Config *conf_temp;

/* general page */
static GtkWidget *startup_dir_entry = NULL;
static GtkWidget *startup_dir_table = NULL;

static void cb_startup_dir_mode (GtkWidget * radiobutton, gpointer data);
static void cb_save_win_state (GtkWidget * checkbutton, gpointer data);
static void cb_startup_dir_browse (GtkWidget * button, gpointer data);
static void cb_startup_dir_browse_ok (GtkWidget * widget, gpointer data);
static void cb_startup_dir_browse_cancel (GtkWidget * widget, gpointer data);
static void cb_startup_dir_current (GtkWidget * button, gpointer data);
static void cb_startup_dir_entry (GtkEditable * editable, gpointer data);

/* dirview page */
static GtkWidget *check_dir_vbox = NULL;

static void cb_check_dir (GtkWidget * checkbutton, gpointer data);
static void cb_check_dir_mode (GtkWidget * radiobutton, gpointer data);
static void cb_show_hidden (GtkWidget * checkbutton, gpointer data);
static void cb_tree_line_style (GtkWidget * button, gpointer data);
static void cb_tree_expander_style (GtkWidget * button, gpointer data);

/* imageview page */
static void cb_image_quality (GtkWidget * button, gpointer data);
static void cb_image_dithering (GtkWidget * button, gpointer data);
static void cb_image_fit (GtkWidget * radiobutton, gpointer data);

/* thumbviw page */
static void cb_thumbnail_quality (GtkWidget * button, gpointer data);
static void cb_enable_thumb_caching (GtkWidget * button, gpointer data);
static void cb_enable_thumb_dirs (GtkWidget * button, gpointer data);
static void cb_thumbview_mode (GtkWidget * radiobutton, gpointer data);

GtkWidget *
prefs_general_page (void)
{
    GtkWidget *main_vbox;
    GtkWidget *vbox1;
    GtkWidget *frame1;
    GtkWidget *button1;
    GtkWidget *button2;
    GSList *vbox1_group = NULL;
    GtkWidget *frame2;
    GtkWidget *vbox2;
    GtkWidget *radiobutton1;
    GtkWidget *radiobutton2;
    GtkWidget *radiobutton3;
    GtkWidget *checkbutton;

    main_vbox = gtk_vbox_new (FALSE, 0);
    gtk_container_set_border_width (GTK_CONTAINER (main_vbox), 10);

    frame1 = gtk_frame_new (" Startup Directory ");
    gtk_box_pack_start (GTK_BOX (main_vbox), frame1, FALSE, FALSE, 0);

    vbox1 = gtk_vbox_new (FALSE, 0);
    gtk_container_set_border_width (GTK_CONTAINER (vbox1), 10);
    gtk_container_add (GTK_CONTAINER (frame1), vbox1);

    radiobutton1 =
	gtk_radio_button_new_with_label (vbox1_group, "Home directory");
    vbox1_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton1));
    gtk_box_pack_start (GTK_BOX (vbox1), radiobutton1, FALSE, FALSE, 0);

    radiobutton2 =
	gtk_radio_button_new_with_label (vbox1_group,
					 "Go to last visited location");
    vbox1_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton2));
    gtk_box_pack_start (GTK_BOX (vbox1), radiobutton2, FALSE, FALSE, 0);

    radiobutton3 =
	gtk_radio_button_new_with_label (vbox1_group,
					 "Go to this directory:");
    vbox1_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton3));
    gtk_box_pack_start (GTK_BOX (vbox1), radiobutton3, FALSE, FALSE, 0);

    startup_dir_table = gtk_table_new (2, 2, FALSE);
    gtk_box_pack_start (GTK_BOX (vbox1), startup_dir_table, TRUE, TRUE, 0);

    startup_dir_entry = gtk_entry_new ();
    gtk_table_attach (GTK_TABLE (startup_dir_table), startup_dir_entry, 0, 1,
		      0, 1, (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
		      (GtkAttachOptions) (0), 0, 0);

    button1 = gtk_button_new_with_label ("Browse...");
    gtk_table_attach (GTK_TABLE (startup_dir_table), button1, 1, 2, 0, 1,
		      (GtkAttachOptions) (GTK_FILL),
		      (GtkAttachOptions) (0), 0, 0);

    button2 = gtk_button_new_with_label ("Current");
    gtk_table_attach (GTK_TABLE (startup_dir_table), button2, 1, 2, 1, 2,
		      (GtkAttachOptions) (GTK_FILL),
		      (GtkAttachOptions) (0), 0, 0);
    gtk_widget_set_usize (button2, 90, -2);

    frame2 = gtk_frame_new (" Window ");
    gtk_box_pack_start (GTK_BOX (main_vbox), frame2, FALSE, FALSE, 10);

    vbox2 = gtk_vbox_new (FALSE, 0);
    gtk_container_set_border_width (GTK_CONTAINER (vbox2), 10);
    gtk_container_add (GTK_CONTAINER (frame2), vbox2);

    checkbutton = gtk_check_button_new_with_label ("Remember window size");
    gtk_box_pack_start (GTK_BOX (vbox2), checkbutton, FALSE, FALSE, 0);


    gtk_widget_set_sensitive (GTK_WIDGET (startup_dir_table), FALSE);


    if (conf_temp->startup_dir_mode == 0)
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (radiobutton1), TRUE);
    else if (conf_temp->startup_dir_mode == 1)
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (radiobutton2), TRUE);
    else
    {
	gtk_entry_set_text (GTK_ENTRY (startup_dir_entry),
			    conf_temp->startup_dir);

	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (radiobutton3), TRUE);
	gtk_widget_set_sensitive (GTK_WIDGET (startup_dir_table), TRUE);
    }

    if (conf_temp->save_win_state)
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton), TRUE);

    gtk_signal_connect (GTK_OBJECT (radiobutton1), "toggled",
			GTK_SIGNAL_FUNC
			(cb_startup_dir_mode), GINT_TO_POINTER (0));

    gtk_signal_connect (GTK_OBJECT (radiobutton2), "toggled",
			GTK_SIGNAL_FUNC
			(cb_startup_dir_mode), GINT_TO_POINTER (1));

    gtk_signal_connect (GTK_OBJECT (radiobutton3), "toggled",
			GTK_SIGNAL_FUNC
			(cb_startup_dir_mode), GINT_TO_POINTER (3));

    gtk_signal_connect (GTK_OBJECT (button1), "clicked",
			GTK_SIGNAL_FUNC (cb_startup_dir_browse), NULL);

    gtk_signal_connect (GTK_OBJECT (button2), "clicked",
			GTK_SIGNAL_FUNC (cb_startup_dir_current), NULL);

    gtk_signal_connect (GTK_OBJECT (startup_dir_entry), "changed",
			GTK_SIGNAL_FUNC (cb_startup_dir_entry), NULL);

    gtk_signal_connect (GTK_OBJECT (checkbutton), "clicked",
			GTK_SIGNAL_FUNC (cb_save_win_state), checkbutton);

    return main_vbox;
}

GtkWidget *
prefs_dirview_page (void)
{
    GtkWidget *main_vbox;
    GtkWidget *frame1;
    GtkWidget *vbox1;
    GtkWidget *checkbutton1;
    GtkWidget *radiobutton1;
    GtkWidget *radiobutton2;
    GtkWidget *checkbutton2;
    GSList *vbox_group = NULL;
    GtkWidget *frame2;
    GtkWidget *table;
    GtkWidget *label1;
    GtkWidget *label2;
    GtkWidget *optionmenu1;
    GtkWidget *optionmenu1_menu;
    GtkWidget *optionmenu2;
    GtkWidget *optionmenu2_menu;
    GtkWidget *menuitem;

    main_vbox = gtk_vbox_new (FALSE, 0);
    gtk_container_set_border_width (GTK_CONTAINER (main_vbox), 10);

    frame1 = gtk_frame_new (" Directory Scan ");
    gtk_box_pack_start (GTK_BOX (main_vbox), frame1, FALSE, TRUE, 0);

    vbox1 = gtk_vbox_new (FALSE, 0);
    gtk_container_set_border_width (GTK_CONTAINER (vbox1), 10);
    gtk_container_add (GTK_CONTAINER (frame1), vbox1);

    checkbutton1 = gtk_check_button_new_with_label ("Check subdirectories");
    gtk_box_pack_start (GTK_BOX (vbox1), checkbutton1, FALSE, FALSE, 0);

    check_dir_vbox = gtk_vbox_new (FALSE, 0);
    gtk_container_set_border_width (GTK_CONTAINER (check_dir_vbox), 5);
    gtk_box_pack_start (GTK_BOX (vbox1), check_dir_vbox, FALSE, FALSE, 0);

    radiobutton1 =
	gtk_radio_button_new_with_label (vbox_group, "Check numer of hard links");
    vbox_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton1));
    gtk_box_pack_start (GTK_BOX (check_dir_vbox), radiobutton1, FALSE, FALSE,
			0);

    radiobutton2 =
	gtk_radio_button_new_with_label (vbox_group,
					 "Do not check numer of hard links");
    vbox_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton2));
    gtk_box_pack_start (GTK_BOX (check_dir_vbox), radiobutton2, FALSE, FALSE,
			0);

    checkbutton2 = gtk_check_button_new_with_label ("Show hidden directories");
    gtk_box_pack_start (GTK_BOX (vbox1), checkbutton2, FALSE, FALSE, 0);

    frame2 = gtk_frame_new (" Style ");
    gtk_box_pack_start (GTK_BOX (main_vbox), frame2, FALSE, TRUE, 10);

    table = gtk_table_new (2, 2, FALSE);
    gtk_container_set_border_width (GTK_CONTAINER (table), 10);

    gtk_container_add (GTK_CONTAINER (frame2), table);

    label1 = gtk_label_new ("Tree line style");
    gtk_table_attach (GTK_TABLE (table), label1, 0, 1, 0, 1,
		      (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
		      (GtkAttachOptions) (0), 0, 0);
    gtk_label_set_justify (GTK_LABEL (label1), GTK_JUSTIFY_LEFT);
    gtk_misc_set_alignment (GTK_MISC (label1), 0, 0.5);

    label2 = gtk_label_new ("Tree expander style");
    gtk_table_attach (GTK_TABLE (table), label2, 0, 1, 1, 2,
		      (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
		      (GtkAttachOptions) (0), 0, 0);
    gtk_label_set_justify (GTK_LABEL (label2), GTK_JUSTIFY_LEFT);
    gtk_misc_set_alignment (GTK_MISC (label2), 0, 0.5);

    optionmenu1 = gtk_option_menu_new ();
    gtk_table_attach (GTK_TABLE (table), optionmenu1, 1, 2, 0, 1,
		      (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
		      (GtkAttachOptions) (0), 0, 0);
    optionmenu1_menu = gtk_menu_new ();
    menuitem = gtk_menu_item_new_with_label ("None");
    gtk_signal_connect (GTK_OBJECT (menuitem), "activate",
			(GtkSignalFunc) cb_tree_line_style,
			GINT_TO_POINTER (GTK_CTREE_LINES_NONE));
    gtk_menu_append (GTK_MENU (optionmenu1_menu), menuitem);
    menuitem = gtk_menu_item_new_with_label ("Solid");
    gtk_signal_connect (GTK_OBJECT (menuitem), "activate",
			(GtkSignalFunc) cb_tree_line_style,
			GINT_TO_POINTER (GTK_CTREE_LINES_SOLID));
    gtk_menu_append (GTK_MENU (optionmenu1_menu), menuitem);
    menuitem = gtk_menu_item_new_with_label ("Dotted");
    gtk_signal_connect (GTK_OBJECT (menuitem), "activate",
			(GtkSignalFunc) cb_tree_line_style,
			GINT_TO_POINTER (GTK_CTREE_LINES_DOTTED));
    gtk_menu_append (GTK_MENU (optionmenu1_menu), menuitem);
    menuitem = gtk_menu_item_new_with_label ("Tabbed");
    gtk_signal_connect (GTK_OBJECT (menuitem), "activate",
			(GtkSignalFunc) cb_tree_line_style,
			GINT_TO_POINTER (GTK_CTREE_LINES_TABBED));

    gtk_menu_append (GTK_MENU (optionmenu1_menu), menuitem);
    gtk_option_menu_set_menu (GTK_OPTION_MENU (optionmenu1),
			      optionmenu1_menu);
    gtk_option_menu_set_history (GTK_OPTION_MENU (optionmenu1),
				 conf_temp->dirtree_line_style);

    optionmenu2 = gtk_option_menu_new ();
    gtk_table_attach (GTK_TABLE (table), optionmenu2, 1, 2, 1, 2,
		      (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
		      (GtkAttachOptions) (0), 0, 0);
    optionmenu2_menu = gtk_menu_new ();
    menuitem = gtk_menu_item_new_with_label ("None");
    gtk_signal_connect (GTK_OBJECT (menuitem), "activate",
			(GtkSignalFunc) cb_tree_expander_style,
			GINT_TO_POINTER (GTK_CTREE_EXPANDER_NONE));
    gtk_menu_append (GTK_MENU (optionmenu2_menu), menuitem);
    menuitem = gtk_menu_item_new_with_label ("Square");
    gtk_signal_connect (GTK_OBJECT (menuitem), "activate",
			(GtkSignalFunc) cb_tree_expander_style,
			GINT_TO_POINTER (GTK_CTREE_EXPANDER_SQUARE));
    gtk_menu_append (GTK_MENU (optionmenu2_menu), menuitem);
    menuitem = gtk_menu_item_new_with_label ("Triangle");
    gtk_signal_connect (GTK_OBJECT (menuitem), "activate",
			(GtkSignalFunc) cb_tree_expander_style,
			GINT_TO_POINTER (GTK_CTREE_EXPANDER_TRIANGLE));
    gtk_menu_append (GTK_MENU (optionmenu2_menu), menuitem);
    menuitem = gtk_menu_item_new_with_label ("Circular");
    gtk_signal_connect (GTK_OBJECT (menuitem), "activate",
			(GtkSignalFunc) cb_tree_expander_style,
			GINT_TO_POINTER (GTK_CTREE_EXPANDER_CIRCULAR));
    gtk_menu_append (GTK_MENU (optionmenu2_menu), menuitem);
    gtk_option_menu_set_menu (GTK_OPTION_MENU (optionmenu2),
			      optionmenu2_menu);
    gtk_option_menu_set_history (GTK_OPTION_MENU (optionmenu2),
				 conf_temp->dirtree_expander_style);

    gtk_signal_connect (GTK_OBJECT (checkbutton1), "clicked",
			GTK_SIGNAL_FUNC (cb_check_dir), checkbutton1);

    gtk_signal_connect (GTK_OBJECT (radiobutton1), "toggled",
			GTK_SIGNAL_FUNC
			(cb_check_dir_mode), GINT_TO_POINTER (0));

    gtk_signal_connect (GTK_OBJECT (radiobutton2), "toggled",
			GTK_SIGNAL_FUNC
			(cb_check_dir_mode), GINT_TO_POINTER (1));

    gtk_signal_connect (GTK_OBJECT (checkbutton2), "clicked",
			GTK_SIGNAL_FUNC (cb_show_hidden), checkbutton2);

    if (conf_temp->check_hlinks)
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (radiobutton1), TRUE);
    else
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (radiobutton2), TRUE);

    if (conf_temp->scan_dir)
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton1), TRUE);
    else
	gtk_widget_set_sensitive (GTK_WIDGET (check_dir_vbox), FALSE);

    if (conf_temp->scan_dir)
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton2), conf_temp->show_hidden);

    return main_vbox;
}

GtkWidget *
prefs_imageview_page (void)
{
    GtkWidget *main_vbox;
    GtkWidget *frame1;
    GtkWidget *table;
    GtkWidget *label1;
    GtkWidget *label2;
    GtkWidget *optionmenu1;
    GtkWidget *optionmenu1_menu;
    GtkWidget *optionmenu2;
    GtkWidget *optionmenu2_menu;
    GtkWidget *menuitem;
    GtkWidget *frame2;
    GtkWidget *vbox;
    GtkWidget *radiobutton1;
    GtkWidget *radiobutton2;
    GSList *vbox_group = NULL;

    main_vbox = gtk_vbox_new (FALSE, 0);
    gtk_container_set_border_width (GTK_CONTAINER (main_vbox), 10);

    frame1 = gtk_frame_new (" Quality ");
    gtk_box_pack_start (GTK_BOX (main_vbox), frame1, FALSE, TRUE, 0);

    table = gtk_table_new (2, 2, TRUE);
    gtk_container_set_border_width (GTK_CONTAINER (table), 10);

    gtk_container_add (GTK_CONTAINER (frame1), table);

    label1 = gtk_label_new ("Dithering method:");
    gtk_table_attach (GTK_TABLE (table), label1, 0, 1, 0, 1,
		      (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
		      (GtkAttachOptions) (0), 0, 0);
    gtk_label_set_justify (GTK_LABEL (label1), GTK_JUSTIFY_LEFT);
    gtk_misc_set_alignment (GTK_MISC (label1), 0, 0.5);

    label2 = gtk_label_new ("Zoom (scaling):");
    gtk_table_attach (GTK_TABLE (table), label2, 0, 1, 1, 2,
		      (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
		      (GtkAttachOptions) (0), 0, 0);
    gtk_label_set_justify (GTK_LABEL (label2), GTK_JUSTIFY_LEFT);
    gtk_misc_set_alignment (GTK_MISC (label2), 0, 0.5);

    optionmenu1 = gtk_option_menu_new ();
    gtk_table_attach (GTK_TABLE (table), optionmenu1, 1, 2, 1, 2,
		      (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
		      (GtkAttachOptions) (0), 0, 0);
    optionmenu1_menu = gtk_menu_new ();
    menuitem = gtk_menu_item_new_with_label ("Nearest (worst, but fastest)");
    gtk_signal_connect (GTK_OBJECT (menuitem), "activate",
			(GtkSignalFunc) cb_image_quality,
			GINT_TO_POINTER (GDK_INTERP_NEAREST));
    gtk_menu_append (GTK_MENU (optionmenu1_menu), menuitem);
    menuitem = gtk_menu_item_new_with_label ("Tiles");
    gtk_signal_connect (GTK_OBJECT (menuitem), "activate",
			(GtkSignalFunc) cb_image_quality,
			GINT_TO_POINTER (GDK_INTERP_TILES));
    gtk_menu_append (GTK_MENU (optionmenu1_menu), menuitem);
    menuitem = gtk_menu_item_new_with_label ("Bilinear");
    gtk_signal_connect (GTK_OBJECT (menuitem), "activate",
			(GtkSignalFunc) cb_image_quality,
			GINT_TO_POINTER (GDK_INTERP_BILINEAR));
    gtk_menu_append (GTK_MENU (optionmenu1_menu), menuitem);
    menuitem = gtk_menu_item_new_with_label ("Hyper (best, but slowest)");
    gtk_signal_connect (GTK_OBJECT (menuitem), "activate",
			(GtkSignalFunc) cb_image_quality,
			GINT_TO_POINTER (GDK_INTERP_HYPER));
    gtk_menu_append (GTK_MENU (optionmenu1_menu), menuitem);
    gtk_option_menu_set_menu (GTK_OPTION_MENU (optionmenu1),
			      optionmenu1_menu);
    gtk_option_menu_set_history (GTK_OPTION_MENU (optionmenu1),
				 conf_temp->image_quality);

    optionmenu2 = gtk_option_menu_new ();
    gtk_table_attach (GTK_TABLE (table), optionmenu2, 1, 2, 0, 1,
		      (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
		      (GtkAttachOptions) (0), 0, 0);
    optionmenu2_menu = gtk_menu_new ();
    menuitem = gtk_menu_item_new_with_label ("None");
    gtk_signal_connect (GTK_OBJECT (menuitem), "activate",
			(GtkSignalFunc) cb_image_dithering,
			GINT_TO_POINTER (GDK_RGB_DITHER_NONE));
    gtk_menu_append (GTK_MENU (optionmenu2_menu), menuitem);
    menuitem = gtk_menu_item_new_with_label ("Normal");
    gtk_signal_connect (GTK_OBJECT (menuitem), "activate",
			(GtkSignalFunc) cb_image_dithering,
			GINT_TO_POINTER (GDK_RGB_DITHER_NORMAL));
    gtk_menu_append (GTK_MENU (optionmenu2_menu), menuitem);
    menuitem = gtk_menu_item_new_with_label ("Best");
    gtk_signal_connect (GTK_OBJECT (menuitem), "activate",
			(GtkSignalFunc) cb_image_dithering,
			GINT_TO_POINTER (GDK_RGB_DITHER_MAX));
    gtk_menu_append (GTK_MENU (optionmenu2_menu), menuitem);
    gtk_option_menu_set_menu (GTK_OPTION_MENU (optionmenu2),
			      optionmenu2_menu);
    gtk_option_menu_set_history (GTK_OPTION_MENU (optionmenu2),
				 conf_temp->image_dithering);

    frame2 = gtk_frame_new (" Zoom ");
    gtk_box_pack_start (GTK_BOX (main_vbox), frame2, FALSE, FALSE, 10);

    vbox = gtk_vbox_new (FALSE, 0);
    gtk_container_set_border_width (GTK_CONTAINER (vbox), 10);

    gtk_container_add (GTK_CONTAINER (frame2), vbox);

    radiobutton1 =
	gtk_radio_button_new_with_label (vbox_group, "Zoom to orginal size");
    vbox_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton1));
    gtk_box_pack_start (GTK_BOX (vbox), radiobutton1, FALSE, FALSE, 0);

    radiobutton2 =
	gtk_radio_button_new_with_label (vbox_group, "Fit image to window");
    vbox_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton2));
    gtk_box_pack_start (GTK_BOX (vbox), radiobutton2, FALSE, FALSE, 0);

    if (conf_temp->image_fit)
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (radiobutton2), TRUE);
    else
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (radiobutton1), TRUE);

    gtk_signal_connect (GTK_OBJECT (radiobutton1), "toggled",
			GTK_SIGNAL_FUNC
			(cb_image_fit), GINT_TO_POINTER (FALSE));

    gtk_signal_connect (GTK_OBJECT (radiobutton2), "toggled",
			GTK_SIGNAL_FUNC
			(cb_image_fit), GINT_TO_POINTER (TRUE));

    return main_vbox;
}

GtkWidget *
prefs_thumbview_page (void)
{
    GtkWidget *main_vbox;
    GtkWidget *frame1;
    GtkWidget *hbox;
    GtkWidget *label1;
    GtkWidget *optionmenu;
    GtkWidget *optionmenu_menu;
    GtkWidget *menuitem;
    GtkWidget *frame2;
    GtkWidget *vbox1;
    GtkWidget *checkbutton1;
    GtkWidget *checkbutton2;
    GtkWidget *frame3;
    GtkWidget *vbox2;
    GSList *vbox_group = NULL;
    GtkWidget *radiobutton1;
    GtkWidget *radiobutton2;

    main_vbox = gtk_vbox_new (FALSE, 0);
    gtk_container_set_border_width (GTK_CONTAINER (main_vbox), 10);

    frame1 = gtk_frame_new (" Quality ");

    gtk_box_pack_start (GTK_BOX (main_vbox), frame1, FALSE, TRUE, 0);

    hbox = gtk_hbox_new (TRUE, 0);
    gtk_container_set_border_width (GTK_CONTAINER (hbox), 10);

    gtk_container_add (GTK_CONTAINER (frame1), hbox);

    label1 = gtk_label_new ("Thumbnail quality:          ");
    gtk_box_pack_start (GTK_BOX (hbox), label1, TRUE, TRUE, 0);
    gtk_label_set_justify (GTK_LABEL (label1), GTK_JUSTIFY_LEFT);
    gtk_misc_set_alignment (GTK_MISC (label1), 0, 0.5);

    optionmenu = gtk_option_menu_new ();
    gtk_box_pack_start (GTK_BOX (hbox), optionmenu, TRUE, TRUE, 0);
    optionmenu_menu = gtk_menu_new ();
    menuitem = gtk_menu_item_new_with_label ("Nearest (worst, but fastest)");
    gtk_signal_connect (GTK_OBJECT (menuitem), "activate",
			(GtkSignalFunc) cb_thumbnail_quality,
			GINT_TO_POINTER (GDK_INTERP_NEAREST));
    gtk_menu_append (GTK_MENU (optionmenu_menu), menuitem);
    menuitem = gtk_menu_item_new_with_label ("Tiles");
    gtk_signal_connect (GTK_OBJECT (menuitem), "activate",
			(GtkSignalFunc) cb_thumbnail_quality,
			GINT_TO_POINTER (GDK_INTERP_TILES));
    gtk_menu_append (GTK_MENU (optionmenu_menu), menuitem);
    menuitem = gtk_menu_item_new_with_label ("Bilinear");
    gtk_signal_connect (GTK_OBJECT (menuitem), "activate",
			(GtkSignalFunc) cb_thumbnail_quality,
			GINT_TO_POINTER (GDK_INTERP_BILINEAR));
    gtk_menu_append (GTK_MENU (optionmenu_menu), menuitem);
    menuitem = gtk_menu_item_new_with_label ("Hyper (best, but slowest)");
    gtk_signal_connect (GTK_OBJECT (menuitem), "activate",
			(GtkSignalFunc) cb_thumbnail_quality,
			GINT_TO_POINTER (GDK_INTERP_HYPER));
    gtk_menu_append (GTK_MENU (optionmenu_menu), menuitem);
    gtk_option_menu_set_menu (GTK_OPTION_MENU (optionmenu), optionmenu_menu);
    gtk_option_menu_set_history (GTK_OPTION_MENU (optionmenu),
				 conf_temp->thumbnail_quality);

    frame2 = gtk_frame_new (" Cache ");
    gtk_box_pack_start (GTK_BOX (main_vbox), frame2, FALSE, TRUE, 10);

    vbox1 = gtk_vbox_new (FALSE, 0);
    gtk_container_set_border_width (GTK_CONTAINER (vbox1), 10);

    gtk_container_add (GTK_CONTAINER (frame2), vbox1);

    checkbutton1 = gtk_check_button_new_with_label ("Cache thumbnails");
    gtk_box_pack_start (GTK_BOX (vbox1), checkbutton1, FALSE, FALSE, 0);

    checkbutton2 =
	gtk_check_button_new_with_label ("Cache thumbnails into .thumbnails");
    gtk_box_pack_start (GTK_BOX (vbox1), checkbutton2, FALSE, FALSE, 0);

    frame3 = gtk_frame_new (" Mode ");
    gtk_box_pack_start (GTK_BOX (main_vbox), frame3, FALSE, TRUE, 10);

    vbox2 = gtk_vbox_new (FALSE, 0);
    gtk_container_set_border_width (GTK_CONTAINER (vbox2), 10);

    gtk_container_add (GTK_CONTAINER (frame3), vbox2);

    radiobutton1 = gtk_radio_button_new_with_label (vbox_group, "list mode");
    vbox_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton1));
    gtk_box_pack_start (GTK_BOX (vbox2), radiobutton1, FALSE, FALSE, 0);

    radiobutton2 =
	gtk_radio_button_new_with_label (vbox_group, "preview mode");
    vbox_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton2));
    gtk_box_pack_start (GTK_BOX (vbox2), radiobutton2, FALSE, FALSE, 0);

    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton1),
				  conf_temp->enable_thumb_caching);
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton2),
				  conf_temp->enable_thumb_dirs);

    if (conf_temp->thumbview_mode == 0)
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (radiobutton1), TRUE);
    else
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (radiobutton2), TRUE);

    gtk_signal_connect (GTK_OBJECT (checkbutton1), "clicked",
			GTK_SIGNAL_FUNC
			(cb_enable_thumb_caching), checkbutton1);

    gtk_signal_connect (GTK_OBJECT (checkbutton2), "clicked",
			GTK_SIGNAL_FUNC (cb_enable_thumb_dirs), checkbutton2);

    gtk_signal_connect (GTK_OBJECT (radiobutton1), "toggled",
			GTK_SIGNAL_FUNC
			(cb_thumbview_mode), GINT_TO_POINTER (0));

    gtk_signal_connect (GTK_OBJECT (radiobutton2), "toggled",
			GTK_SIGNAL_FUNC
			(cb_thumbview_mode), GINT_TO_POINTER (1));

    return main_vbox;
}

/* general page callback function */

static void
cb_startup_dir_mode (GtkWidget * radiobutton, gpointer data)
{
    gint    idx = GPOINTER_TO_INT (data);

    if (!GTK_TOGGLE_BUTTON (radiobutton)->active)
	return;

    switch (idx)
    {
      case 0:
	  conf_temp->startup_dir_mode = 0;
	  break;
      case 1:
	  conf_temp->startup_dir_mode = 1;
	  break;
      case 3:
	  conf_temp->startup_dir_mode = 2;
	  break;
      default:
	  break;
    }

    gtk_widget_set_sensitive (GTK_WIDGET (startup_dir_table),
			      conf_temp->startup_dir_mode == 2);
}

static void
cb_save_win_state (GtkWidget * checkbutton, gpointer data)
{
    conf_temp->save_win_state =
	gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (data));
}

static void
cb_startup_dir_browse (GtkWidget * button, gpointer data)
{
    GtkWidget *file_dialog;

    file_dialog = gtk_file_selection_new ("");
    gtk_widget_set_sensitive (GTK_FILE_SELECTION (file_dialog)->file_list,
			      FALSE);

    gtk_widget_hide (GTK_FILE_SELECTION (file_dialog)->fileop_del_file);
    gtk_widget_hide (GTK_FILE_SELECTION (file_dialog)->fileop_ren_file);
    gtk_widget_hide (GTK_FILE_SELECTION (file_dialog)->selection_entry);
    gtk_widget_hide (GTK_FILE_SELECTION (file_dialog)->selection_text);

    gtk_signal_connect (GTK_OBJECT
			(GTK_FILE_SELECTION (file_dialog)->ok_button),
			"clicked",
			GTK_SIGNAL_FUNC (cb_startup_dir_browse_ok),
			file_dialog);

    gtk_signal_connect (GTK_OBJECT
			(GTK_FILE_SELECTION (file_dialog)->cancel_button),
			"clicked",
			GTK_SIGNAL_FUNC (cb_startup_dir_browse_cancel),
			file_dialog);

    gtk_widget_show (file_dialog);
}

static void
cb_startup_dir_browse_ok (GtkWidget * widget, gpointer data)
{
    gtk_entry_set_text (GTK_ENTRY (startup_dir_entry),
			gtk_file_selection_get_filename (GTK_FILE_SELECTION
							 (data)));

    gtk_widget_destroy (data);
}

static void
cb_startup_dir_browse_cancel (GtkWidget * widget, gpointer data)
{
    gtk_widget_destroy (data);
}

static void
cb_startup_dir_current (GtkWidget * button, gpointer data)
{
    gtk_entry_set_text (GTK_ENTRY (startup_dir_entry),
			browser->current_path->str);
}

static void
cb_startup_dir_entry (GtkEditable * editable, gpointer data)
{
    if (conf_temp->startup_dir)
	g_free (conf_temp->startup_dir);

    conf_temp->startup_dir =
	g_strdup (gtk_entry_get_text (GTK_ENTRY (startup_dir_entry)));
}

/* dirview page callback functions */

static void
cb_check_dir (GtkWidget * checkbutton, gpointer data)
{
    conf_temp->scan_dir =
	gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (data));

    if (conf_temp->scan_dir)
	gtk_widget_set_sensitive (GTK_WIDGET (check_dir_vbox), TRUE);
    else
	gtk_widget_set_sensitive (GTK_WIDGET (check_dir_vbox), FALSE);
}

static void
cb_check_dir_mode (GtkWidget * radiobutton, gpointer data)
{
    gint    idx = GPOINTER_TO_INT (data);

    if (!GTK_TOGGLE_BUTTON (radiobutton)->active)
	return;

    switch (idx)
    {
      case 0:
	  conf_temp->check_hlinks = TRUE;
	  break;
      case 1:
	  conf_temp->check_hlinks = FALSE;
	  break;
      default:
	  break;
    }
}

static void cb_show_hidden (GtkWidget * checkbutton, gpointer data)
{
    conf_temp->show_hidden =
	gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (data));
}

static void
cb_tree_line_style (GtkWidget * button, gpointer data)
{
    gint    idx = GPOINTER_TO_INT (data);

    conf_temp->dirtree_line_style = idx;
}

static void
cb_tree_expander_style (GtkWidget * button, gpointer data)
{
    gint    idx = GPOINTER_TO_INT (data);

    conf_temp->dirtree_expander_style = idx;
}

/* imageview page callback functions */

static void
cb_image_quality (GtkWidget * button, gpointer data)
{
    gint    idx = GPOINTER_TO_INT (data);

    conf_temp->image_quality = idx;
}

static void
cb_image_dithering (GtkWidget * button, gpointer data)
{
    gint    idx = GPOINTER_TO_INT (data);

    conf_temp->image_dithering = idx;
}

static void
cb_image_fit (GtkWidget * radiobutton, gpointer data)
{
    gint    idx = GPOINTER_TO_INT (data);

    if (!GTK_TOGGLE_BUTTON (radiobutton)->active)
	return;

    conf_temp->image_fit = idx;
}

/* thumbview page callback functions */

static void
cb_thumbnail_quality (GtkWidget * button, gpointer data)
{
    gint    idx = GPOINTER_TO_INT (data);

    conf_temp->thumbnail_quality = idx;
}

static void
cb_enable_thumb_caching (GtkWidget * button, gpointer data)
{
    conf_temp->enable_thumb_caching =
	gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (data));
}

static void
cb_enable_thumb_dirs (GtkWidget * button, gpointer data)
{
    conf_temp->enable_thumb_dirs =
	gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (data));
}

static void
cb_thumbview_mode (GtkWidget * radiobutton, gpointer data)
{
    gint    idx = GPOINTER_TO_INT (data);

    if (!GTK_TOGGLE_BUTTON (radiobutton)->active)
	return;

    conf_temp->thumbview_mode = idx;
}
